"""POSIX 加密库调用和相关功能的封装模块. (crypt)"""

导入 crypt

套路 生成盐值(方法=空, *, 轮数=空):
    """为指定方法生成一个盐值.

    若未指定方法, 则使用可用的最强方法.

    """
    返回 crypt.mksalt(方法, rounds=轮数)

套路 加密(密码, 盐值=空):
    """返回一个代表密码单向哈希值的字符串, 盐值前置.

    ``盐值`` 若未指定或为 ``空``, 则选择可用的最强方法并生成盐值. 否则,
    ``盐值`` 可以是 ``crypt.METHOD_*`` 值中的一个, 或是 ``密室.生成盐值()``
    所返回的字符串.

    """
    返回 crypt.crypt(密码, 盐值)
